#!/usr/bin/env python
import sys
import xmlrpclib
import socket
import time
import getopt
import os
import thread
#just for sending

def writeLogFile(strmes,logfile,timestamp = False):
    f = open(logfile,'a')
    if (timestamp):
        f.write(str(int(time.time()))+":"+strmes+"\n")
    else:
        f.write(strmes+"\n")
    f.close()
def main():
    response_time_threshold = 0.2
    count_threshold = 2
    window_length = 3
    windows = []
    skip_time = 1000
    opts, args = getopt.getopt(sys.argv[1:],"hi:o:",["help"])
    dirList = os.listdir("./")
    n = len("workload")
    inputfile = "workload"
    for fname in dirList:
        if fname[:n] == "workload":
            inputfile = fname
            break    
    
    outputfile = "SLO.log" 
    for opt,arg in opts:
        if opt in ("-h, --help"):
            sys.exit(2)
        if opt in ("-i"):
            inputfile = arg
        if opt in ("-o"):
            outputfile = arg
    if os.path.exists(outputfile):
        os.remove(outputfile)              
    print "Reading Workload File"
    inputF = open(inputfile,"r")
    for i in range(400):
        line=inputF.readline() #ignore the training data
    count = 0
    for i in range(window_length):
        windows.append(0)
    c  = 1
    first_time = 0
    while inputF:
        line=inputF.readline()
        if len(line)<3:
            break
        array = line.split('|')

        if float(array[3]) > response_time_threshold:
            if (first_time == 0):
                first_time = int(array[0])
            windows[count] = 1
        else:
            windows[count] = 0

        if (sum(windows)>=count_threshold):    
            c += 1
            print "ALERT ", str(first_time)
            for i in range(len(windows)):
                windows[i] = 0
            writeLogFile(str(first_time),outputfile)
            for i in range(skip_time):
                   line=inputF.readline() #ignore the training data    
            for i in range(len(windows)):
                windows[i] = 0    
        if (sum(windows)==0):
            first_time = 0
        count += 1
        if count >= len(windows):
            count = count-len(windows)          

    print "Total:"+str(c)
if __name__ == "__main__":
    main()
